#include <stdio.h>

#include "Evaluador.h"

//Para buscar fugas de memoria
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>

void main()
{
	//Instancia el evaluador de expresiones
	Evaluador objEvaluar;

	printf("El resultado es: [%s] es %d\n", "2++4", objEvaluar.iAnalizaSintaxis("2++4"));
	printf("El resultado es: [%s] es %d\n", "2-(4+)-7", objEvaluar.iAnalizaSintaxis("2-(4+)-7"));
	printf("El resultado es: [%s] es %d\n", "2-(*3)", objEvaluar.iAnalizaSintaxis("2-(*3)"));
	printf("El resultado es: [%s] es %d\n", "/12-5*2", objEvaluar.iAnalizaSintaxis("/12-5*2"));
	printf("El resultado es: [%s] es %d\n", "12-67*", objEvaluar.iAnalizaSintaxis("12-67*"));
	printf("El resultado es: [%s] es %d\n", "3-(((2*4)", objEvaluar.iAnalizaSintaxis("3-(((2*4)"));
	printf("El resultado es: [%s] es %d\n", "2-()*3", objEvaluar.iAnalizaSintaxis("2-()*3"));
	printf("El resultado es: [%s] es %d\n", "2+3)-2*(4", objEvaluar.iAnalizaSintaxis("2+3)-2*(4"));
	printf("El resultado es: [%s] es %d\n", "(12-4)7-1", objEvaluar.iAnalizaSintaxis("(12-4)7-1"));
	printf("El resultado es: [%s] es %d\n", "7-2(5-6)", objEvaluar.iAnalizaSintaxis("7-2(5-6)"));
	printf("El resultado es: [%s] es %d\n", "3-2..4+1", objEvaluar.iAnalizaSintaxis("3-2..4+1"));
	printf("El resultado es: [%s] es %d\n", "xyz(45)", objEvaluar.iAnalizaSintaxis("xyz(45)"));
	printf("El resultado es: [%s] es %d\n", "2-sen5", objEvaluar.iAnalizaSintaxis("2-sen5"));
	printf("El resultado es: [%s] es %d\n", "17-(sen)+78", objEvaluar.iAnalizaSintaxis("17-(sen)+78"));
	printf("El resultado es: [%s] es %d\n", "12cos(3)", objEvaluar.iAnalizaSintaxis("12cos(3)"));
	printf("El resultado es: [%s] es %d\n", "3-xy+2*ab", objEvaluar.iAnalizaSintaxis("3-xy+2*ab"));
	printf("El resultado es: [%s] es %d\n", "7-x(5-6)", objEvaluar.iAnalizaSintaxis("7-x(5-6)"));
	printf("El resultado es: [%s] es %d\n", "(12-4)y-1", objEvaluar.iAnalizaSintaxis("(12-4)y-1"));
	printf("El resultado es: [%s] es %d\n", "4-z.1+3", objEvaluar.iAnalizaSintaxis("4-z.1+3"));
	printf("El resultado es: [%s] es %d\n", "7-2.p+1", objEvaluar.iAnalizaSintaxis("7-2.p+1"));
	printf("El resultado es: [%s] es %d\n", "3x+1", objEvaluar.iAnalizaSintaxis("3x+1"));
	printf("El resultado es: [%s] es %d\n", "4/2", objEvaluar.iAnalizaSintaxis("4/2"));
	printf("El resultado es: [%s] es %d\n", "4/0", objEvaluar.iAnalizaSintaxis("4/0"));
	printf("El resultado es: [%s] es %d\n", "4/a/0", objEvaluar.iAnalizaSintaxis("4/a/0"));
	printf("El resultado es: [%s] es %d\n", "4/0.2+1", objEvaluar.iAnalizaSintaxis("4/0.2+1"));
	printf("El resultado es: [%s] es %d\n", "(4/0.00000000000000002)", objEvaluar.iAnalizaSintaxis("(4/0.00000000000000002)"));
	printf("El resultado es: [%s] es %d\n", "(4/0.000000000000000/2)", objEvaluar.iAnalizaSintaxis("(4/0.000000000000000/2)"));
	printf("El resultado es: [%s] es %d\n", "(3+@)", objEvaluar.iAnalizaSintaxis("(3+@)"));
	
	//Le enva ecuacin a analizar
	objEvaluar.vAnaliza("1+2+3+4+5+6+7+8+9+10-9-8-7-6-5-4-3-2-1-10*2");

	//Da valor a la variable x
	objEvaluar.fVariables['x']=1;

	//Evalua la expresin
	float fValor = objEvaluar.fEvaluar();

	//Imprime el valor con x=90
	printf("Valor fijo: %f\n", fValor);

	//Cambiando el valor de x continuamente
	/*for (int iCont=1; iCont<=100; iCont++)
	{
		objEvaluar.fVariables['x']=(float)iCont;
		fValor = objEvaluar.fEvaluar();
		printf("Ciclo de valor: %f\n", fValor);
	}*/

	//Libera la memoria del evaluador de expresiones
	objEvaluar.vLiberaMemoria();

	//Imprime las fugas de memoria
	_CrtDumpMemoryLeaks();

	getchar();
}
